#include<bits/stdc++.h>
using namespace std;
struct povezanost{
	int x, y;
};
struct zalog{
	int osoba, zlatnik;
};
int main(){
	int n, q, premestaj;
	cin>>n;
	vector<povezanost>a(n-1);
	for(int i=0; i<n-1; i++){
		cin>>a[i].x>>a[i].y;
	}
	vector<int>brz(n);
	for(int i=0; i<n; i++){
		cin>>brz[i];
	}
	cin>>q;
	vector<zalog>b(q);
	for(int i=0; i<q; i++){
		cin>>b[i].osoba>>b[i].zlatnik;
	}
	int pom;
	for(int i=1; i<=n; i++){
		if(pom<brz[i])pom=brz[i];
		else if(pom>brz[i])premestaj=i;
	}
	cout<<premestaj;
}